//Disable $fn and $fa, do not change these
$fn=0;
$fa=0.01;
$fs=0.5;


m3r=1.6;
m3hr=3;
m3hh=2;


backthickness=8;
backheight=66;
backdepth=55;

pegsquareheight=24;
pegsquaredepth=24;
pegdiameter=3;
centrediameter=3;
centrey=backdepth/2;
centrez=backheight/2;

centreheadthickness=3;
centreheaddiameter=5;


module nut()
{
    cylinder(5,r = 5.5 / 2 / cos(180 / 6) + 0.2, $fn=6);
}

module back()
{
 difference()
 {   
  cube([backthickness,backdepth,backheight]);

// centre mount hole
    
  translate([0,centrey,centrez])rotate([0,90,0]) cylinder(backthickness,d1=centrediameter,d2=centrediameter);

  translate([backthickness-centreheadthickness,centrey,centrez])rotate([0,90,0]) cylinder(centreheadthickness,d=centreheaddiameter);

// mount holes

  translate([0,centrey+pegsquaredepth/2,centrez])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);


  translate([0,centrey+pegsquaredepth/2,centrez])rotate([0,90,0]) nut();


  translate([0,centrey-pegsquaredepth/2,centrez])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);

  translate([0,centrey-pegsquaredepth/2,centrez])rotate([0,90,0]) nut();


// peg matrix
     
  translate([0,centrey+pegsquaredepth/2,centrez+pegsquareheight/2])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);
     
  translate([0,centrey-pegsquaredepth/2,centrez+pegsquareheight/2])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);

  translate([0,centrey+pegsquaredepth/2,centrez-pegsquareheight/2])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);

  translate([0,centrey-pegsquaredepth/2,centrez-pegsquareheight/2])rotate([0,90,0]) cylinder(backthickness,d1=pegdiameter,d2=pegdiameter);
     
 }   
}


sensethickness=3;
sensedepth=10;
senseheight=33;
sensesocketthickness=12;
sensesocketheight=6;
sensesolderthickness=3;
sensesolderheight=12;
sensesolderoffset=14;
sensepin1offset=29.5;
sensepin2offset=10.5;
sensepindiameter=2.8;
sensepinthickness=3;
senseoffset=8;

module sensor()
{
    
 cube([sensethickness,sensedepth,senseheight]);    
 cube([sensesocketthickness+sensethickness,sensedepth,sensesocketheight]);   
 translate([0,0,sensesolderoffset]) cube([sensesolderthickness+sensethickness,sensedepth,sensesolderheight]);
 translate([0,sensedepth/2,sensepin1offset]) rotate([0,90,0]) cylinder(sensepinthickness+sensethickness,d1=sensepindiameter,d2=sensepindiameter);
    
 translate([0,sensedepth/2,sensepin2offset]) rotate([0,90,0]) cylinder(sensepinthickness+sensethickness,d1=sensepindiameter,d2=sensepindiameter);
    
}


difference()
{
back();

translate([0,backdepth+0.01,senseheight+backheight/2-senseheight/2+senseoffset/2]) rotate([180,0,0])sensor();
    
translate([0,sensedepth,senseheight+backheight/2-senseheight/2+senseoffset/2]) rotate([180,0,0]) sensor();
    
}




translate([0,-60,0]) rotate([90,0,0]) rotate([0,90,0]) import("/home/david/Documents/Projects/3D Projects/Hypercube/Extruder_Mount_1.0.stl");




